VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Demo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Although you could place the connection objects (or even the command and result set) in
'the objects init, this causes scalability problems.  All clients must use one connection.
'In general it is better to create and close a connection in each method and let connection
'pooling handle the management of a connection pool.
Const gSystem = "RCHASBDS"
Const gUserId = "DDILLING"
Const gPwd = ""

Public Function GetCustomer(CustomerID As String, DistID As String, WareHouseID As String, _
                           FirstName As String, MiddleName As String, LastName As String, _
                           Addr1 As String, Addr2 As String, City As String, State As String, _
                           Zip As String, Phone As String) As Boolean
Dim cn As New ADODB.Connection
Dim cnix As New AD400.Connection

Dim ix As AD400.Index
Dim cm As New ADODB.Command
Dim rs As New ADODB.Recordset

Dim bookmark
Dim keys

   On Error GoTo DspErr
   GetCustomer = True

   cn.Open "Provider=IBMDA400;Data Source=" & gSystem & ";", gUserId, gPwd
   cnix.Open gSystem, gUserId, gPwd

   Set cm.ActiveConnection = cn
   cm.CommandText = "/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)"
   cm.Properties("Updatability") = 0
   
   'Open it
   rs.Open cm, , , , adCmdTable
   Set ix = cnix.OpenIndex("/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)", "/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)")
   
   'Find/position to key
   On Error Resume Next
   keys = CStr(Format(CInt(CustomerID), "0000"))
   bookmark = ix.GetBookmark(keys, ad400SeekFirstEQ)
   On Error GoTo DspErr
   If VarType(bookmark) <> vbEmpty And VarType(bookmark) <> vbNull Then
      rs.Move 0, bookmark
   Else
      GetCustomer = False        'Key not found
   End If
      
   'return the data
   DistID = rs.Fields("CDID").Value
   WareHouseID = rs.Fields("CWID").Value
   FirstName = rs.Fields("CFIRST").Value
   MiddleName = rs.Fields("CINIT").Value
   LastName = rs.Fields("CLAST").Value
   Addr1 = rs.Fields("CADDR1").Value
   Addr2 = rs.Fields("CADDR2").Value
   City = rs.Fields("CCITY").Value
   State = rs.Fields("CSTATE").Value
   Zip = rs.Fields("CZIP").Value
   Phone = rs.Fields("CPHONE").Value
   
   GoTo GetCustomerExit
   
DspErr:
    'Obviously a better solution can be found for returning an error
    ' (raise an error or create a special parameter) but for now fill in the error message
    ' text in the address field.
   GetCustomer = False
   Addr1 = cn.Errors(0).Description
   Addr2 = Err.Description
   Resume GetCustomerExit             'Re-Enable error handler
    
GetCustomerExit:
    On Error Resume Next        'Ignore errors if objects are not open
    Set ix = Nothing
    rs.Close
    Set rs = Nothing
    Set cm = Nothing
    Set cn = Nothing
    Set cnix = Nothing

   
End Function
Public Function AddCustomer(CustomerID As String, DistID As String, WareHouseID As String, _
                           FirstName As String, MiddleName As String, LastName As String, _
                           Addr1 As String, Addr2 As String, City As String, State As String, _
                           Zip As String, Phone As String) As Boolean
Dim cn As New ADODB.Connection
Dim cnix As New AD400.Connection

Dim ix As AD400.Index
Dim cm As New ADODB.Command
Dim rs As New ADODB.Recordset

Dim bookmark
Dim keys

   On Error GoTo DspErr
   AddCustomer = True

   cn.Open "Provider=IBMDA400;Data Source=" & gSystem & ";", gUserId, gPwd
   'cnix.Open gSystem, gUserId, gPwd


   Set cm.ActiveConnection = cn
   cm.CommandText = "/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)"
   cm.Properties("Updatability") = 7
   
   'Open it
   rs.Open cm, , , , adCmdTable
   
   'Only adds some fields so must specify

    Flds = Array("CID", "CDID", "CWID", "CFIRST", "CINIT", "CLAST", "CADDR1", "CADDR2", _
                    "CCITY", "CSTATE", "CZIP", "CPHONE")
    Vals = Array(CustomerID, DistID, WareHouseID, _
                           FirstName, MiddleName, LastName, _
                           Addr1, Addr2, City, State, _
                           Zip, Phone)
    rs.AddNew Flds, Vals
   
   GoTo GetCustomerExit
   
DspErr:
    'Obviously a better solution can be found for returning an error
    ' (raise an error or create a special parameter) but for now fill in the error message
    ' text in the address field.
   AddCustomer = False
   Addr1 = cn.Errors(0).Description
   Addr2 = Err.Description
   Resume GetCustomerExit             'Re-Enable error handler

GetCustomerExit:
    On Error Resume Next        'Ignore errors if objects are not open
    'Set ix = Nothing
    rs.Close
    Set rs = Nothing
    Set cm = Nothing
    Set cn = Nothing
    'Set cnix = Nothing

   
End Function

Public Function UpdateCustomer(CustomerID As String, DistID As String, WareHouseID As String, _
                           FirstName As String, MiddleName As String, LastName As String, _
                           Addr1 As String, Addr2 As String, City As String, State As String, _
                           Zip As String, Phone As String) As Boolean
Dim cn As New ADODB.Connection
Dim cnix As New AD400.Connection

Dim ix As AD400.Index
Dim cm As New ADODB.Command
Dim rs As New ADODB.Recordset

Dim bookmark
Dim keys

   On Error GoTo DspErr
   UpdateCustomer = True

   cn.Open "Provider=IBMDA400;Data Source=" & gSystem & ";", gUserId, gPwd
   cnix.Open gSystem, gUserId, gPwd


   Set cm.ActiveConnection = cn
   cm.CommandText = "/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)"
   cm.Properties("Updatability") = 7
   
   'Open it
   rs.Open cm, , , , adCmdTable
   Set ix = cnix.OpenIndex("/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)", "/QSYS.LIB/APILIB.LIB/CSTMR.FILE(*FIRST, *NONE)")
   
   'Find/position to key
   On Error Resume Next
   keys = CStr(Format(CInt(CustomerID), "0000"))
   bookmark = ix.GetBookmark(keys, ad400SeekFirstEQ)
   On Error GoTo DspErr
   If VarType(bookmark) <> vbEmpty And VarType(bookmark) <> vbNull Then
      rs.Move 0, bookmark
   Else
      UpdateCustomer = False        'Key not found
      GoTo UpdateCustomerExit
   End If
   
   'Only uses some fields so must specify each one
    Flds = Array("CID", "CDID", "CWID", "CFIRST", "CINIT", "CLAST", "CADDR1", "CADDR2", _
                    "CCITY", "CSTATE", "CZIP", "CPHONE")
    Vals = Array(CustomerID, DistID, WareHouseID, _
                           FirstName, MiddleName, LastName, _
                           Addr1, Addr2, City, State, _
                           Zip, Phone)
    rs.Update Flds, Vals
   
   GoTo UpdateCustomerExit
   
DspErr:
    'Obviously a better solution can be found for returning an error
    ' (raise an error or create a special parameter) but for now fill in the error message
    ' text in the address field.
   UpdateCustomer = False
   Addr1 = cn.Errors(0).Description
   Addr2 = Err.Description
   Resume UpdateCustomerExit            'Re-Enable error handler
   
UpdateCustomerExit:
    On Error Resume Next        'Ignore errors if objects are not open
    Set ix = Nothing
    rs.Close
    Set rs = Nothing
    Set cm = Nothing
    Set cn = Nothing
    Set cnix = Nothing

   
End Function

